<?php

namespace Drp\NativeEventApp\Http\Controllers;

use Drp\NativeEventApp\Http\Requests\NewFileUpload;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Response;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\Storage;

class HandleFileUpload extends Controller
{
    public function __invoke(NewFileUpload $request): JsonResponse
    {
        $stats = fstat($request->getContent(true));
        if ($stats['size'] === 0) {
            return response()->json(
                ['error' => 'You must provide some content in your request to store in the file.'],
                Response::HTTP_UNPROCESSABLE_ENTITY
            );
        }

        Storage::disk(config('native-event-app.files.local.disk'))
            ->writeStream(
                config('native-event-app.files.local.path') . '/' . $request->get('uuid'),
                $request->getContent(true)
            );

        return response()->json([
            'id' => $request->get('uuid'),
        ], 200);
    }
}
