<?php

namespace Drp\NativeEventApp\Modules\Types\Form;

use Drp\NativeEventApp\Modules\Types\Actions\Action;
use Drp\NativeEventApp\Modules\Types\Container;

/**
 * @method static make(string $name): \Drp\NativeEventApp\Modules\Types\Form\Form
 */
class Form extends Container
{
    /** @var string */
    public $name;

    /** @var Action */
    public $onSubmit;

    public function __construct(string $name)
    {
        $this->name = $name;
    }

    public static function getDescription(): string
    {
        return 'A form container';
    }

    public function onSubmit(Action $action): self
    {
        $this->onSubmit = $action;

        return $this;
    }

    public function setOnSubmit(array $onSubmit): void
    {
        $this->onSubmit = Action::fromArray($onSubmit);
    }
}
