<?php
/** @var \Illuminate\Database\Eloquent\Factory $factory */

use Drp\NativeEventApp\Enums\NotificationStatus;
use Drp\NativeEventApp\Models\Device;
use Drp\NativeEventApp\Models\Event;
use Drp\NativeEventApp\Models\FailedNotification;
use Drp\NativeEventApp\Models\Notification;
use Faker\Generator as Faker;

$factory->define(Notification::class, static function (Faker $faker): array {
    return [
        'event_id' => factory(Event::class)->create()->id,
        'title' => $faker->name,
        'message' => $faker->sentence,
        'status' => NotificationStatus::DRAFT,
        'send_at' => null,
        'sent_at' => null,
        'total_sent' => 0,
    ];
});

$factory->state(Notification::class, 'published', static function (): array {
    return [
        'status' => NotificationStatus::PUBLISHED,
    ];
});

$factory->define(FailedNotification::class, static function (Faker $faker): array {
    return [
        'notification_id' => factory(Notification::class)->state('published')->create([
            'sent_at' => now()->subMinute(),
        ])->id,
        'device_id' => factory(Device::class)->create()->id,
        'error' => $faker->sentence,
    ];
});
