<?php

namespace Drp\NativeEventApp\Test\Unit;

use Drp\NativeEventApp\Auth\ContactDetail;
use Drp\NativeEventApp\Enums\AuthMethod;
use Drp\NativeEventApp\PhoneNumber;
use Drp\NativeEventApp\Test\TestCase;

class ContactDetailTest extends TestCase
{
    /** @test */
    public function can_convert_to_string()
    {
        $sms = new ContactDetail(AuthMethod::SMS(), '07474747474');

        $this->assertEquals('07474747474', (string) $sms);
    }

    /** @test */
    public function can_call_methods_on_sub_object()
    {
        $sms = new ContactDetail(AuthMethod::SMS(), '07474747474');

        $this->assertEquals(
            (new PhoneNumber('07474747474'))->internationalized(),
            $sms->internationalized()
        );
    }
}
