<?php

namespace Drp\NativeEventApp\Test\Unit\Modules;

use Drp\NativeEventApp\Facades\ModulesUnSerializer;
use Drp\NativeEventApp\Modules\Modules;
use Drp\NativeEventApp\Modules\Types\Actions\Action;
use Drp\NativeEventApp\Modules\Types\Form\Button;
use Drp\NativeEventApp\Modules\Types\SimpleContainer;
use Drp\NativeEventApp\Modules\Types\Touchable;
use Drp\NativeEventApp\Test\TestCase;

class ButtonTest extends TestCase
{
    /** @test */
    public function tracks_on_press()
    {
        $button = Button::make('Submit')->onPress(Action::submit());

        $this->assertEquals([
            'label' => 'Submit',
            'onPress' => [
                'type' => 'SUBMIT',
                'payload' => [],
            ],
            'styles' => [],
            'className' => [],
            'viewableBy' => [],
        ], $button->getAttributes());
    }

    /** @test */
    public function is_serializable()
    {
        $button = Button::make('Submit')->onPress(Action::submit());

        $serializedModule = json_encode([$button]);
        $module = ModulesUnSerializer::getModulesFromString($serializedModule)->first();

        $this->assertInstanceOf(Button::class, $module);
        $this->assertEquals(Action::SUBMIT, $module->onPress->type());
        $this->assertEquals([], $module->onPress->payload());
    }
}
