<?php

namespace Drp\NativeEventApp\Test\Unit\Modules;

use Drp\NativeEventApp\Facades\ModulesUnSerializer;
use Drp\NativeEventApp\Modules\Modules;
use Drp\NativeEventApp\Modules\Types\Actions\Action;
use Drp\NativeEventApp\Modules\Types\Form\Button;
use Drp\NativeEventApp\Modules\Types\Form\TextInput;
use Drp\NativeEventApp\Modules\Types\SimpleContainer;
use Drp\NativeEventApp\Modules\Types\Touchable;
use Drp\NativeEventApp\Test\TestCase;

class TextBoxTest extends TestCase
{
    /** @test */
    public function is_serializable(): void
    {
        $textBox = TextInput::make('input');

        $serializedModule = json_encode([$textBox]);
        $module = ModulesUnSerializer::getModulesFromString($serializedModule)->first();

        $this->assertInstanceOf(TextInput::class, $module);
        $this->assertFalse($module->required);
    }

    /** @test */
    public function it_can_set_the_required_flag(): void
    {
        $textBox = TextInput::make('required-input')->required();

        $serializedModule = json_encode([$textBox]);
        $module = ModulesUnSerializer::getModulesFromString($serializedModule)->first();

        $this->assertInstanceOf(TextInput::class, $module);
        $this->assertTrue($module->required);
    }
}
