<?php

namespace Drp\NativeEventApp\Test\Unit\Templates;

use DateTime;
use Drp\NativeEventApp\Templates\DataType;
use Drp\NativeEventApp\Test\TestCase;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Carbon;

class DataTypeTest extends TestCase
{
    protected function setUp(): void
    {
    }

    /** @test */
    public function can_calculate(): void
    {
        $this->assertTrue(DataType::DATE()->is(DataType::calculate(new \DateTime())));
        $this->assertTrue(DataType::DATE()->is(DataType::calculate(Carbon::now())));
        $this->assertTrue(DataType::STRING()->is(DataType::calculate('test')));
        $this->assertTrue(DataType::BOOL()->is(DataType::calculate(true)));
        $this->assertTrue(DataType::INT()->is(DataType::calculate(1)));
        $this->assertTrue(DataType::ARRAY()->is(DataType::calculate(['test'])));
        $this->assertTrue(DataType::OBJECT()->is(DataType::calculate((object) ['test'])));
    }

    /** @test */
    public function can_get_from_class_name()
    {
        $this->assertTrue(DataType::DATE()->is(DataType::fromClassName(DateTime::class)));
        $this->assertTrue(DataType::DATE()->is(DataType::fromClassName(Carbon::class)));
        $this->assertTrue(DataType::STRING()->is(DataType::fromClassName('string')));
        $this->assertTrue(DataType::BOOL()->is(DataType::fromClassName('bool')));
        $this->assertTrue(DataType::INT()->is(DataType::fromClassName('int')));
        $this->assertTrue(DataType::ARRAY()->is(DataType::fromClassName('array')));
        $this->assertTrue(DataType::OBJECT()->is(DataType::fromClassName('object')));
        $this->assertTrue(DataType::OBJECT()->is(DataType::fromClassName(Model::class)));
    }
}
